#include <my_assert.h>

/* test powers of two, AKA "M" packing type of CB_FLAG_PACKING_M */

#define H(c)    (((((c) + 9) * ((c) + 2) * 401) >> 1) & 0xFF)
#define H2(c)   (H((c) * 13))

#define M               2000

void test (int n)
{
    unsigned char *r[M];
    int i, j;

    printf("running %d\n", n);

    for (i = 0; i < M; i++) {
        r[i] = (unsigned char *) malloc (n);
        memset (r[i], 'A', n);
        r[i][0] = H (i);
        r[i][n - 1] = H2 (i);
        for (j = 0; j <= i; j++) {
            assert (r[j][0] == H (j));
            assert (r[j][n - 1] == H2 (j));
        }
    }

    for (i = 0; i < M; i += 2) {

// printf("%d %p %d %d\n", i, r[i], (int) r[i][0], (int) r[i][n - 1]);

        assert (r[i][0] == H (i));
        assert (r[i][n - 1] == H2 (i));

        memset (r[i], 'Z', n);

        free (r[i]);

        for (j = i + 1; j < M; j++) {
            assert (r[j][0] == H (j));
            assert (r[j][n - 1] == H2 (j));
        }
        for (j = 1; j < i; j += 2) {
            assert (r[j][0] == H (j));
            assert (r[j][n - 1] == H2 (j));
        }
    }

    for (i = 1; i < M; i += 2) {
        assert (r[i][0] == H (i));
        assert (r[i][n - 1] == H2 (i));
        memset (r[i], 'Z', n);
        free (r[i]);
        for (j = i + 2; j < M; j += 2) {
            assert (r[j][0] == H (j));
            assert (r[j][n - 1] == H2 (j));
        }
    }
}

void entry (void)
{
    int r;
    for (r = 2; r <= 2048; r <<= 1)
        test (r);
}



